---
layout: docs
title:  "Min Plus Algebra"
section: "data"
source: "algebird-core/src/main/scala/com/twitter/algebird/MinPlus.scala"
scaladoc: "#com.twitter.algebird.MinPlus"
---

# Min Plus Algebra

The Min-Plus algebra, or tropical semi-ring is useful for computing shortest paths on graphs.

- [Min-plus Matrix Product](http://en.wikipedia.org/wiki/Min-plus_matrix_multiplication)

The shortest path from i->j in k or less steps is ((G)^k)_{ij}

- [Tropical Geometry](http://en.wikipedia.org/wiki/Tropical_geometry)
- [Semiring definition](http://en.wikipedia.org/wiki/Semiring)

### Documentation Help

We'd love your help fleshing out this documentation! You can edit this page in your browser by clicking [this link](https://github.com/twitter/algebird/edit/develop/docs/src/main/tut/datatypes/min_plus.md). These links might be helpful:

- [MinPlus.scala](https://github.com/twitter/algebird/blob/develop/algebird-core/src/main/scala/com/twitter/algebird/MinPlus.scala)
- [MinPlusLaws.scala](https://github.com/twitter/algebird/blob/develop/algebird-test/src/test/scala/com/twitter/algebird/MinPlusLaws.scala)
