---
layout: page
title:  "Resources for Learners"
section: "resources_for_learners"
position: 3
---
## Tutorials

- [Of Algebirds, Monoids, Monads, and Other Bestiary for Large-Scale Data Analytics](http://www.michael-noll.com/blog/2013/12/02/twitter-algebird-monoid-monad-for-large-scala-data-analytics), by [Michael Noll](https://twitter.com/miguno)
- [Algebird: a Tweet by Tweet Guide](https://twitter.com/i/moments/772269989587881984) by [Pardis Noorzad](https://twitter.com/djpardis)
- [Top K Users, Using Algebird Bloomfilter in Spark](https://venukanaparthy.wordpress.com/2016/01/09/top-k-users-using-algebird-bloomfilter-in-spark/), by [Venu Kanaparthi](https://twitter.com/singhkorner/)

## Presentations

- [Count-Min Sketch in Real Data Applications](https://skillsmatter.com/skillscasts/6844-count-min-sketch-in-real-data-applications), by [Laura Bledaite](https://twitter.com/eigenlaura)
- [Algebird](https://www.youtube.com/watch?v=wTE56cpttTk), by [Ian O'Connell](https://twitter.com/ianoc)
- [Add ALL the things: Abstract Algebra meets Analytics](https://www.infoq.com/presentations/abstract-algebra-analytics), by [Avi Bryant](https://twitter.com/avibryant)
- [scala.collection.approximate](https://www.youtube.com/watch?v=yzitqjUI6ok), by [Avi Bryant](https://twitter.com/avibryant)
- [Life after Monoids](https://www.youtube.com/watch?v=xO9AoZNSOH4), by [Tom Switzer](https://twitter.com/tixxit)
- [Twitter Algebird Approximations](https://www.youtube.com/watch?v=0zqcACoD7kM) by [Martin Odersky](https://twitter.com/odersky)

## Slides

- [Algebird: Abstract Algebra for big data analytics](https://speakerdeck.com/samklr/algebird-abstract-algebra-for-big-data-analytics) at Devoxx 2014, by [Samir Bessalah](https://twitter.com/samklr)
- [Data-cubing made simple with Spark, Algebird and HBase](https://speakerdeck.com/vidma/data-cubing-made-simple-with-spark-algebird-and-hbase) by Vidmantas Zemleris
- [Algebra for Scalable Analytics](http://cdn.oreillystatic.com/en/assets/1/event/105/Algebra%20for%20Scalable%20Analytics%20Presentation.pdf), by [Oscar Boykin](https://twitter.com/posco)
- [Counting with Algebird and Spark](http://esumitra.github.io/algebird-boston-spark), by [esumitra](https://github.com/esumitra)
- [Aggregators: modeling data queries functionally](https://speakerdeck.com/johnynek/aggregators-modeling-data-queries-functionally), by [Oscar Boykin](https://twitter.com/posco)

## Papers

- [Monoidify! Monoids as a Design Principle for Efficient MapReduce Algorithms](https://arxiv.org/abs/1304.7544) by [Jimmy Lin](https://twitter.com/lintool)

## Books

- [Notes on Abstract Algebra](http://www.math.usm.edu/perry/old_classes/mat423fa11/notes_25aug2011.pdf) by University of Southern Mississipi professor [John Perry](http://www.math.usm.edu/perry/)
- [Functional Programming in Scala](https://www.manning.com/books/functional-programming-in-scala) by Paul Chiusano and Rúnar Bjarnason - While this book does not specifically cover Algebird, it's a great introduction to functional programming in Scala in general and covers some of the abstractions that can be found in Algebird.
